unit frmTest1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    txtHost: TEdit;
    txtPort: TEdit;
    cmdConectar: TButton;
    cmdDesconectar: TButton;
    Timer1: TTimer;
    txtLocal: TLabel;
    txtRemoto: TLabel;
    procedure cmdConectarClick(Sender: TObject);
    procedure cmdDesconectarClick(Sender: TObject);
    procedure Memo1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses unitSocketStream;

{$R *.DFM}

var
  conexion : TSocketStream;
  bufferrecibir : string;

procedure TForm1.cmdConectarClick(Sender: TObject);
begin
  bufferrecibir := '';
  conexion := TSocketStream.Connect (txtHost.Text, StrToInt(txtPort.Text));
  Timer1.Enabled := True;
  Memo1.ReadOnly := False;
  Memo1.Clear;
  Memo1.SetFocus;
  cmdDesconectar.Enabled := True;
  cmdConectar.Enabled := False;
  txtLocal.Caption := conexion.LocalHost + ':' + IntToStr(conexion.LocalPort);
  txtRemoto.Caption := conexion.RemoteHost + ':' + IntToStr(conexion.RemotePort);
end;

procedure TForm1.cmdDesconectarClick(Sender: TObject);
begin
  Timer1.Enabled := False;
  conexion.Destroy;
  cmdDesconectar.Enabled := False;
  cmdConectar.Enabled := True;
  Memo1.ReadOnly := True;
end;

procedure TForm1.Memo1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  p : PChar;
begin
  If Key = 13 Then
  begin
    p := PChar (Memo1.Lines[Memo1.CaretPos.y-1] + #13#10);
    conexion.Write (p^, strlen (p));
  end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  c : char;
begin
  While conexion.CanRead do
  begin
    If conexion.Read (c, 1) > 0 Then
    begin
      bufferrecibir := bufferrecibir + c;
      If c = #10 Then
      begin
        Memo1.Lines.Add (Trim(bufferrecibir));
        bufferrecibir := '';
        Memo1.SelStart := Memo1.GetTextLen;
      end;
    end else
    begin
      {Si nos devuelve 0 bytes es que la conexin se cerr}
      cmdDesconectarClick (Sender);
      Exit;
    end;
  end;
end;

end.
