unit frmTest2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, frmTest2Conexion, unitSocketStream;

type
  TForm1 = class(TForm)
    txtHost: TEdit;
    txtPort: TEdit;
    cmdIniciar: TButton;
    cmdDetener: TButton;
    Timer1: TTimer;
    procedure cmdIniciarClick(Sender: TObject);
    procedure cmdDetenerClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

var
  servidor : TSocketStream;

procedure TForm1.cmdIniciarClick(Sender: TObject);
begin
  servidor := TSocketStream.Listen (txtHost.Text, StrToInt(txtPort.Text));
  cmdIniciar.Enabled := False;
  cmdDetener.Enabled := True;
  Timer1.Enabled := True;
end;

procedure TForm1.cmdDetenerClick(Sender: TObject);
begin
  Timer1.Enabled := False;
  servidor.Destroy;
  cmdIniciar.Enabled := True;
  cmdDetener.Enabled := False;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  form : TForm2;
begin
  While servidor.CanAccept do
  begin
    Application.CreateForm(TForm2, form);
    form.Visible := True;
    form.cliente := servidor.Accept;
    form.txtLocal.Caption := form.cliente.LocalHost + ':' + IntToStr(form.cliente.LocalPort);
    form.txtRemoto.Caption := form.cliente.RemoteHost + ':' + IntToStr(form.cliente.RemotePort);
    form.Timer1.Enabled := True;
  end;
end;

end.
