unit frmTest2Conexion;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, unitSocketStream,
  StdCtrls, ExtCtrls;

type
  TForm2 = class(TForm)
    Memo1: TMemo;
    Timer1: TTimer;
    txtLocal: TLabel;
    txtRemoto: TLabel;
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Memo1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
    cliente : TSocketStream;
    readbuffer : string;
  end;

var
  Form2: TForm2;

implementation

{$R *.DFM}

procedure TForm2.Timer1Timer(Sender: TObject);
var
  c : char;
begin
  While cliente.CanRead do
  begin
    If cliente.Read (c, 1) = 0 Then
    begin
      Memo1.ReadOnly := True;
      Timer1.Enabled := False;
      Caption := 'Desconectado.';
      Exit;
    end;
    readbuffer := readbuffer + c;
    If c = #10 Then
    begin
      Memo1.Lines.Add (Trim(readbuffer));
      Memo1.SelStart := Memo1.GetTextLen;
      readbuffer := '';
    end;
  end;
end;

procedure TForm2.FormCreate(Sender: TObject);
begin
  readbuffer := '';
end;

procedure TForm2.Memo1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  p : PChar;
begin
  If Key = 13 Then
  begin
    p := PChar(Memo1.Lines[Memo1.CaretPos.y-1]+#13#10);
    cliente.Write (p^, strlen(p));
  end;
end;

procedure TForm2.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Timer1.Enabled := False;
  cliente.Destroy;
end;

end.
 